#!/bin/sh

appType="idrive";
EvsSynoArmBin="https://www.$appType.com/downloads/linux/download-options/IDrive_synology_ARM.zip";
EvsSynoBin32_64="https://www.$appType.com/downloads/linux/download-options/IDrive_synology_64bit.zip";
EvsSynoAlphine="https://www.$appType.com/downloads/linux/download-options/IDrive_synology_Alpine.zip";
EvsSynoPpcQoriq="https://www.$appType.com/downloads/linux/download-options/IDrive_synology_Ppc_Qoriq.zip";
EvsSynoPpcQ853="https://www.$appType.com/downloads/linux/download-options/IDrive_synology_Ppc_853x.zip";
EvsSynoPpcQ824="https://www.$appType.com/downloads/linux/download-options/IDrive_synology_Ppc_824x.zip";
EvsSynoAarch64="https://www.$appType.com/downloads/linux/download-options/IDrive_synology_aarch64.zip";
EvsBin32="https://www.$appType.com/downloads/linux/download-options/IDrive_linux_32bit.zip";
EvsBin64="https://www.$appType.com/downloads/linux/download-options/IDrive_linux_64bit.zip";
#EvsUnvBin="https://www.$appType.com/downloads/linux/download-options/IDrive_linux_universal.zip";
EvsQnapArmBin="https://www.$appType.com/downloads/linux/download-options/IDrive_QNAP_ARM.zip";
EvsQnapBin64="https://www.$appType.com/downloads/linux/download-options/IDrive_QNAP_64bit.zip";
EvsQnapBin32="https://www.$appType.com/downloads/linux/download-options/IDrive_QNAP_32bit.zip";
EvsNetgArmBin="https://www.$appType.com/downloads/linux/download-options/IDrive_Netgear_ARM.zip";
EvsNetgBin32_64="https://www.$appType.com/downloads/linux/download-options/IDrive_Netgear_64bit.zip";
#EvsSolaris32="https://www.$appType.com/downloads/linux/download-options/IDrive_solaris_32bit.zip";

libLink="https://www.idrive.com/downloads/nas-servers/libpopt.so.0.0.0";

currentDir=$PWD;
binaryPath=$1;

#Get Machine type and get evs link sequence
machineType="$2";
wgetPath="/usr/bin/wget";

if [ ! -e $wgetPath ]; then
	wgetPath=`which wget`;
fi

if [ "$machineType" == "synology" ]; then
	# check machine type and create library link for evs if required
	unameOut=`uname -m`;

	if [ ! -e "/lib32/libpopt.so.0" ] && [ "$unameOut" == "x86_64" ]; then
		rm "/lib32/libpopt.so.0" 2>>/dev/null ;
		libFile=`echo "$libLink" | cut -d/ -f7`;
		pathSep="/";
		dum="${currentDir}${pathSep}${libFile}";
		rm "$dum" 2>>/dev/null;
		$wgetPath --no-check-certificate --no-proxy $libLink;
		cmd="ln -s $dum /lib32/libpopt.so.0";
		`$cmd`;
	fi
fi

MACHINE_ARCH=$(uname -m)
MACHINE_ARCH_DATA=$(uname -a)

if [ "$machineType" == "synology" ] && [ `echo "${MACHINE_ARCH_DATA}" | grep -c "alpine" ` -gt 0 ]; then
	arrayLinks="$EvsSynoAlphine $EvsSynoArmBin $EvsQnapArmBin $EvsNetgArmBin";
elif [ "$machineType" == "synology" ] && [ `echo "${MACHINE_ARCH}" | grep -i 'armv'` ]; then
	arrayLinks="$EvsSynoArmBin $EvsSynoAlphine $EvsQnapArmBin $EvsNetgArmBin";
elif [ "$machineType" == "synology" ] && [ "${MACHINE_ARCH}" == 'i686' ]; then
	arrayLinks="$EvsSynoBin32_64 $EvsBin32 $EvsQnapBin32 $EvsNetgBin32_64";
elif [ "$machineType" == "synology" ] && [ "${MACHINE_ARCH}" == 'x86' ]; then
	arrayLinks="$EvsSynoBin32_64 $EvsBin32 $EvsQnapBin32 $EvsNetgBin32_64";
elif [ "$machineType" == "synology" ] && [ "${MACHINE_ARCH}" == 'x86_64' ]; then
	arrayLinks="$EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsQnapBin64 $EvsNetgBin32_64";
elif [ "$machineType" == "synology" ] && [ "${MACHINE_ARCH}" == 'aarch64' ]; then
	arrayLinks="$EvsSynoAarch64 $EvsSynoBin32_64 $EvsBin64 $EvsQnapBin64 $EvsNetgBin32_64";
elif [ "$machineType" == "synology" ]; then
	arrayLinks="$EvsSynoPpcQoriq $EvsSynoPpcQ853 $EvsSynoPpcQ824 $EvsBin32 $EvsBin64 $EvsSynoArmBin $EvsSynoBin32_64 $EvsSynoAlphine $EvsSynoAarch64 $EvsQnapArmBin $EvsQnapBin64 $EvsNetgArmBin $EvsNetgBin32_64 $EvsQnapBin32";
elif [ "$machineType" == "qnap" ] && [ `echo "${MACHINE_ARCH}" | grep -i 'armv'` ]; then
	arrayLinks="$EvsQnapArmBin $EvsSynoArmBin $EvsSynoAlphine $EvsNetgArmBin";
elif [ "$machineType" == "qnap" ] && [ "${MACHINE_ARCH}" == 'i686' ]; then
	arrayLinks="$EvsQnapBin32 $EvsSynoBin32_64 $EvsBin32 $EvsNetgBin32_64";
elif [ "$machineType" == "qnap" ] && [ "${MACHINE_ARCH}" == 'x86' ]; then
	arrayLinks="$EvsQnapBin32 $EvsSynoBin32_64 $EvsBin32 $EvsNetgBin32_64";
elif [ "$machineType" == "qnap" ] && [ "${MACHINE_ARCH}" == 'aarch64' ]; then
	arrayLinks="$EvsSynoAarch64 $EvsSynoBin32_64 $EvsBin64 $EvsQnapBin64 $EvsNetgBin32_64";
elif [ "$machineType" == "qnap" ] && [ "${MACHINE_ARCH}" == 'x86_64' ]; then
	arrayLinks="$EvsQnapBin64 $EvsQnapBin32 $EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsNetgBin32_64";
elif [ "$machineType" == "netgear" ] && [ `echo "${MACHINE_ARCH}" | grep -i 'armv'` ]; then
	arrayLinks="$EvsNetgArmBin $EvsSynoArmBin $EvsSynoAlphine $EvsQnapArmBin";
elif [ "$machineType" == "netgear" ] && [ "${MACHINE_ARCH}" == 'x86_64' ]; then
	arrayLinks="$EvsNetgBin32_64 $EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsQnapBin64 $EvsQnapBin32";
elif [ "$machineType" == "netgear" ] && [ "${MACHINE_ARCH}" == 'i686' ]; then
	arrayLinks="$EvsNetgBin32_64 $EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsQnapBin64 $EvsQnapBin32";
elif [ "$machineType" == "netgear" ] && [ "${MACHINE_ARCH}" == 'x86' ]; then
	arrayLinks="$EvsNetgBin32_64 $EvsSynoBin32_64 $EvsBin32 $EvsBin64 $EvsQnapBin64 $EvsQnapBin32";	
elif [ "$machineType" == "Asustor" ] && [ "${MACHINE_ARCH}" == 'i686' ]; then
	arrayLinks="$EvsBin32 $EvsSynoBin32_64 $EvsQnapBin32 $EvsNetgBin32_64";
elif [ "$machineType" == "Asustor" ] && [ "${MACHINE_ARCH}" == 'x86' ]; then
	arrayLinks="$EvsBin32 $EvsSynoBin32_64 $EvsQnapBin32 $EvsNetgBin32_64";
elif [ "$machineType" == "Asustor" ] && [ "${MACHINE_ARCH}" == 'x86_64' ]; then
	arrayLinks="$EvsBin64 $EvsBin32 $EvsSynoBin32_64 $EvsQnapBin64 $EvsNetgBin32_64";
else
	arrayLinks="$EvsBin32 $EvsBin64 $EvsSynoArmBin $EvsSynoBin32_64 $EvsSynoAlphine $EvsQnapArmBin $EvsQnapBin64 $EvsNetgArmBin $EvsNetgBin32_64 $EvsQnapBin32 $EvsSynoPpcQoriq $EvsSynoPpcQ853 $EvsSynoPpcQ824 $EvsSynoAarch64";
fi

#Remove temp files of previous execution
if [ -e "checkEvs.txt" ]; then
	rmItem=`cat "checkEvs.txt"`;
	if  [ $rmItem != "" ] && [ $rmItem != "/" ] && [ -e $rmItem ]; then
		rm -rf "$rmItem"
	fi
fi

#Get zip/unzip type
sevenUnzip=`which 7z`;
if [ $sevenUnzip ]; then
       unzip="$sevenUnzip x";
else        
       unzip=`which unzip`;        
fi    
binary_Export () {
	zipFilesName='';
	zipName=`echo $idriveBinaryPath | cut -d/ -f7`;
	zipFilesName=$zipFilesName$zipName, ;	
	echo "$zipName" > "checkEvs.txt";
        $wgetPath --no-check-certificate --no-proxy $idriveBinaryPath;
        $unzip "$zipName";
        rm "$zipName";
        zipFullPath=`echo "$zipName" | cut -d. -f1`;
		evsDir="$currentDir/$zipFullPath";
        evs="$evsDir/idevsutil";
		echo "$evsDir" > "checkEvs.txt";
		rm "checkEvs.txt"
        chmod 0777 "$evs";
		evsHelpRes=`"$evs" -h`;		
		evsHelpRes1=`echo $?`;
		if [ $evsHelpRes1 == '0' ];
		then
			if [ $workStat -eq 0 ]; then
				cp $evs "$binaryPath";
			else
				cp $evs $binaryPath"_Dedup";
			fi
			workStat=1;	
        fi
		if [ $evsDir != "/" ]; then
			rm -rf "$evsDir";
		fi 
}
workStat=0;
for i in $arrayLinks
do
		idriveBinaryPath=$i;
		binary_Export
		
		if [ $workStat -eq 1 ]; then
			#idriveBinaryPath=`echo ${i//.zip/_Dedup.zip}`;
			idriveBinaryPath=`echo ${i//download-options/download-options-dedup}`;
			binary_Export
			break;
		fi
done

echo "";
echo "";
echo "Send the below details to support:";
echo "------------------------------------";
echo "Machine Details: $machineType";
if [ $workStat -eq 1 ]; then
	echo "Working zip are $zipFilesName";
elif [ $workStat -eq 0 ]; then
	echo "Unable to find compatible evs binary";
fi	
