<?php
include 'fetchPath.php';
define('RESULTFILE', "result.txt");
define('COUNTFILE', "count.txt");
$lastLine = "";
$filename = "";
$hidden = "Enabled";
$totalFileCount = 0;
$notExistCount = 0;
$count = 0;
$excludePartialPath = $userDir.PATHSEPARATOR.EXCLUDE_PARTIALPATH;
$countArr = array();
$isFolderEmpty = true;
$errNo = 0;

if(file_exists($excludePartialPath)){
        $excludeParArray = file($excludePartialPath); #read the whole file into an array in a single stretch
	if(count($excludeParArray)){
        $tmp = trim($excludeParArray[0],LINEFEED);
        if($tmp === '\/.') 
			$hidden = "Disabled";
    }
}

#parsing output for search and finding list of missing files in local
$OUTPUTFILE = fopen(OUTPUTFILE,"r");
if(!$OUTPUTFILE){
	$errNo = 2;
	errorCleanup($errNo);
}

# create a file with item count of missing files locally
if(!file_exists(COUNTFILE)){
	if($COUNTFD = fopen(COUNTFILE,"w")){
		fclose($COUNTFD);
		chmod(COUNTFILE, PERMISSIONVAL);
	}
	else {
		traceLog("Unable to open file ".COUNTFILE);
		$errNo = 2;
		errorCleanup($errNo);
	}
}

# create a file with list of files missing locally
if(!$RESULT = fopen(RESULTFILE,"a")){
	traceLog("Unable to open file ".RESULTFILE);
	$errNo = 3;
	errorCleanup($errNo);
}
chmod(RESULTFILE,PERMISSIONVAL);

if($COUNT_FILE = fopen(COUNTFILE,"r")){
	$countArr = file(COUNTFILE);
	fclose($COUNT_FILE);
	if(!empty($countArr)){
		$totalFileCount += trim($countArr[2]);
		$notExistCount += trim($countArr[3]);
	}
}
else {
	traceLog("Unable to open file ".COUNTFILE);
	return;
}
$i=0;
while(1){
	$buffer = fread($OUTPUTFILE, LIMIT); 
	if(empty($buffer)){
		if(customFileSize(ERRORFILE)){
			$error = file_get_contents(ERRORFILE);
			checkDedupDeviceError($error);
			break;
		}
        
		if(!file_exists(PIDFILE)){
			traceLog(PIDFILE." does not exist.");
			$errNo = 4;
			errorCleanup($errNo);
		}
		
		sleep(1);
		fseek($OUTPUTFILE, 0, 1);		#to clear eof flag
		continue;
	}
	
	//need to check appending partial record to packet or to first line of packet
	if(!empty($lastLine))
		$buffer = $lastLine.$buffer;

	if(file_exists($dedupDetailFile)){
		if(substr($buffer,-1) !== "\n"){
			$lastNewlinePos = strrpos($buffer, "\n");
			$resultList = substr($buffer,0,$lastNewlinePos+1);
			$lastLine   = substr($buffer,$lastNewlinePos+1);
		} else {
			$resultList = $buffer;
			$lastLine = '';
		}
		
		#if(preg_match('/items_found/', $resultList))		
		if(strpos($resultList,'items_found') !== FALSE)		
			$flag = 1;
		
		$noOfLines  = substr_count($resultList,"\n");
		$resultListXML = "<root>$resultList</root>";
		$xml = simplexml_load_string($resultListXML);
		if(!$xml){
			traceLog("Not XML: \n \n".$resultListXML);
			if($flag == 1)
				break;
			continue;
		}
		foreach ($xml->item as $value)
		{
			if(++$i%100 === 0)
				usleep(1000); // 1000 == 1 millisecond
			
			if(isset($value['items_found']))
				break;
			
			$filename = trim($value['fname'],"\n");
			$itemType = trim($value['restype']);
			# check for file existance 
			if(!empty($filename) && $itemType === "F"){
				if(strpos($filename,"/.") !== FALSE && ($hidden === 'Disabled'))
					continue;
				
				++$totalFileCount;
				if(!file_exists($filename)){
					# check if filename is starts with "/" and check for non admin permission
					if(strpos($filename,"/") === 0){
						++$notExistCount;
						fwrite($RESULT,$filename.LINEFEED);
					}
					else 
						traceLog("Unable to consider for archive. item name: $filename and backupLocation: $backupLocation");
				} 
				else 
					$isFolderEmpty = false;
			
				$countArr[0] = $errNo;
				$countArr[1] = $filename;
				$countArr[2] = $totalFileCount;
				$countArr[3] = $notExistCount;
				updateCountFile($countArr);
			}
		}
	} else {
		$resultList = explode(LINEFEED, trim($buffer));
		$bufIndex = count($resultList);
		
		if(substr($buffer,-1) !== "\n"){      
			#keep last line of buffer only when it not ends with newline.
			$lastLine = array_pop($resultList);
			# In case of partial or line ending with new line both case we need to reduce the index by one
			--$bufIndex;
		}
		else
			$lastLine = "";
		
		$flag = 0;
		if(0 < $bufIndex and strpos($resultList[$bufIndex-1],"Total files found") !== FALSE){
			$flag = 1;
		}

		$backupLocation = "/".ltrim(readBackupLocation(),"/");
		$len = strlen($backupLocation);
		
		foreach($resultList as $key => $item){
			++$count;
			if(!($count%10) && !file_exists(PIDFILE)){
				traceLog(PIDFILE." file does not exist.");
				$errNo = 4;
				$count = 0;
				errorCleanup($errNo);
			}
			
			$filename = "";	
			$fields = explode("] [",$item,6);
			if(count($fields) < 6)
				continue;

			$fields[2] = ltrim($fields[2]);
			if($fields[2] !== "0"){
				# remove backup location from beginning in string
				$fields[5] = substr($fields[5], $len);
				# remove last character ] from last field
				$fields[5] = preg_replace("/.$/","",$fields[5]);
				# remove spaces from beginning from required fields
				$fields[5] = ltrim($fields[5]);
				$filename = $fields[5];
				
				# check for file existance 
				if(!empty($filename)){		
					if(strpos($filename,"/.") !== FALSE && ($hidden === 'Disabled'))
						continue;
					
					++$totalFileCount;
					if(!file_exists($filename)){
						# check if filename is starts with "/" and check for non admin permission
						if(strpos($filename,"/") === 0){
							++$notExistCount;
							fwrite($RESULT,$backupLocation.$filename.LINEFEED);
						}
						else 
							traceLog("Unable to consider for archive. item name: $filename and backupLocation: $backupLocation");
					} 
					else 
						$isFolderEmpty = false;
				
					$countArr[0] = $errNo;
					$countArr[1] = $filename;
					$countArr[2] = $totalFileCount;
					$countArr[3] = $notExistCount;
					updateCountFile($countArr);
				}
			}
		}
	}
	if(1 === $flag)
		break;
}
print $isFolderEmpty;
errorCleanup($errNo);

#****************************************************************************************************
# Subroutine Name         : errorCleanup
# Objective               : To complete the error cleanup
# Added By                : Pooja Havaldar
#*****************************************************************************************************/
function errorCleanup($errNo)
{
	GLOBAL $countArr, $RESULT, $OUTPUTFILE;
	if($errNo == 0)
		$errNo = 1;
		
	$countArr[0] = $errNo;
	updateCountFile($countArr);
	fclose($RESULT);
	fclose($OUTPUTFILE);
	exit;
}

#****************************************************************************************************
# Subroutine Name         : updateCountFile
# Objective               : Update the count file with latest content
# Added By                : Kamalraj
#*****************************************************************************************************/
function updateCountFile($countArr=array())
{
    // $countStr = trim(implode(LINEFEED,$countArr));
	$countStr ='';
	foreach($countArr as $val){
		$countStr .= trim($val,"\n").LINEFEED;
	}
	$countStr = trim($countStr);
	file_put_contents(COUNTFILE,$countStr);
	@chmod(COUNTFILE,PERMISSIONVAL);
}
?>
