<?php
error_reporting(0);

define('APPDIR', 'IDrive');
define('SERVICE', 'idriveIt');
define('SYNOLOGY','synology');
define('QNAP','qnap');
define('NETGEAR','netgear');
define('TWOTIER','twotier');
define('ASUSTOR','Asustor');

if(!isset($argv[1]) || !trim($argv[1])){
	exit('Enter machine name');
}

$machine_type = $argv[1];
$webDirPath = "";

if($machine_type == SYNOLOGY){
	$webDirPath = "/var/services/web/";
	$perlPath = "/usr/bin/perl";
	$phpPath = "/usr/bin/php";
	$cronPath = "/etc/crontab";
}
else if($machine_type == QNAP){
	/*$getWebPath = `/sbin/getcfg SHARE_DEF defWeb -d Qweb -f /etc/config/def_share.info`;
	$getWebPath = trim($getWebPath); 
	$webDirPath = "/share/".$getWebPath."/";*/
	$webDirPath = "/share/Web/";
	$perlPath = "/opt/bin/perl";
	$phpPath = "/mnt/ext/opt/apache/bin/php";
	$cronPath = "/etc/config/crontab";
}
else if($machine_type == NETGEAR){
	$webDirPath = "/apps/idrive/web/";
	$perlPath = "/usr/bin/perl";
	$phpPath = "/usr/bin/php";
	$cronPath = "/etc/crontab";
	doCleanup();
}
else if($machine_type == TWOTIER){
	$webDirPath = "/usr/local/www/";
	$perlPath = "/usr/pbi/idrive-amd64/bin/perl";
	$phpPath = "/usr/pbi/idrive-amd64/bin/php";
	$cronPath = "/etc/crontab";
}
else if($machine_type == ASUSTOR){
	$webDirPath = "/usr/local/www/";
	$perlPath = "/usr/bin/perl";
	$phpPath = "/usr/builtin/bin/php";
	$cronPath = "/var/spool/cron/crontabs/root";
	$binaryPath = $webDirPath.APPDIR;
	cronPerltoPhpUpdate();
	doCleanup();
}

if ($machine_type != TWOTIER){
	$command = "which php";
	$phpPathVal=shell_exec($command);
	$phpPathVal = trim($phpPathVal);

	if($phpPathVal != ''){
		$phpPath = $phpPathVal;
	}

	$command = "which perl";
	$perlPathVal=shell_exec($command);
	$perlPathVal = trim($perlPathVal);

	if($perlPathVal != ''){
		$perlPath = $perlPathVal;
	}
}
$binaryPath = $webDirPath.APPDIR;
// added by anil to trigger logout after update based on this file check.
$filePath = "$binaryPath/logout.txt";
if(file_put_contents($filePath,"freshInstall"))
	chmod($filePath,PERMISSIONVAL);
cronPerltoPhpUpdate();

if(($machine_type == NETGEAR) || ($machine_type == QNAP)){

	validateIdevsutil();
	if($machine_type == QNAP){
		$suPath = $binaryPath."/.config/su";
		$copiedSu = $binaryPath."/su";
		if(file_exists($copiedSu))
			`mv $copiedSu $suPath`;
		
		if(!validateSu($suPath) || !file_exists($suPath)){
			system("sh $binaryPath/.scripts/suBinaryChk.sh $binaryPath/.config/ $machine_type");
		}
		`chmod 04755 $suPath`;
		
		$downloads = $binaryPath."/Downloads";
		if (!is_dir($downloads)){
			`mkdir $downloads`;
			`chmod 777 $downloads`;
		}
	}
}
else if($machine_type == SYNOLOGY){

	$unameOut = `uname -m`;
	$pwd = `pwd`;
	$unameOut = trim($unameOut);
	$orgLibDir = $webDirPath.APPDIR."/.config";
	$orgLib  = "libpopt.so.0.0.0";
	$libPath = "/usr/lib";	
	$libLinkPath = "libpopt.so.0";
	if("x86_64" == $unameOut)
		$libPath = "/usr/lib32";
	
	chdir($libPath);
	if(is_link($libLinkPath))
	{
		if(!file_exists($libLinkPath))
		{
			if(!file_exists($orgLib))
				getCompatibleLibpopt($unameOut,$orgLibDir,$libPath);
		}
		else 
		{		
			$readLink = trim(readlink($libLinkPath));
			if($readLink == "$orgLibDir/$orgLib")
				getCompatibleLibpopt($unameOut,$orgLibDir,$libPath);
		}
		unlink($libLinkPath);
		`ln -s $orgLib $libLinkPath`;
	}
	else if(!file_exists($libLinkPath))
	{
		if(!file_exists($orgLib))
			getCompatibleLibpopt($unameOut,$orgLibDir,$libPath);
		
		`ln -s $orgLib $libLinkPath`;
	}

	$pwd = trim($pwd);
	chdir($pwd);
	$dsmVersion6 = isDSM6();
	doCleanup($dsmVersion6);
}
$appServiceDir = $webDirPath.SERVICE;
if(!file_exists($appServiceDir))
	`mkdir $appServiceDir`;

`chmod -R 0777 $appServiceDir`;

/*********************************************************************************************************
* Subroutine Name       : isDSM6
* Objective             : To find, is this DSM 6
* Added By              : Sabin Cheruvattil | 2016-11-25
**********************************************************************************************************/
function isDSM6()
{
	$dsmVersionArr = explode("\n", `cat /etc.defaults/VERSION`);
	array_walk($dsmVersionArr, 'trim');
	
	if(preg_match("/\"6\"$/", $dsmVersionArr[0])) {
		return TRUE;
	}	
	return FALSE;
}

/*********************************************************************************************************
* Subroutine Name       : doCleanup
* Objective             : Restart php-fpm & httpd servers.
* Added By              : Sabin Cheruvattil | 2016-11-28
**********************************************************************************************************/
function doCleanup($isDSM6=0)
{
	GLOBAL $phpFpmConfPath, $phpNameArray, $machine_type, $webDirPath;
	# This is still a guess, we will try to find the actual path to it.
	getPHPConfdPath($isDSM6);

	foreach($phpFpmConfPath as $additionalConfPath){
		$additionalConfPath = trim($additionalConfPath);
		if($additionalConfPath == '') {
			continue;
		}
		if($machine_type == ASUSTOR){
			$orgIni = "/usr/local/AppCentral/".APPDIR."/www/.scripts/".APPDIR.".ini";
		} else if($machine_type == SYNOLOGY){
			$orgIni = "/var/packages/".APPDIR."/target/".APPDIR.".ini";
		} else if($machine_type == NETGEAR){
			$orgIni = $webDirPath.APPDIR."/.scripts/".APPDIR.".ini";
		}
		$newIni = $additionalConfPath."/".APPDIR.".ini";
		if(is_link($newIni)){
			unlink($newIni);
		}
		`ln -s $orgIni $newIni`;
	}
	
	
	if($machine_type == ASUSTOR){
		`/usr/builtin/sbin/apache2 -k restart`;
	} else if ($isDSM6) {
		foreach($phpNameArray as $phpversion) {
			if ($phpversion == "php") {
				`initctl restart $phpversion-fpm`;
			}
			else {
				`initctl restart pkg-$phpversion-fpm`;
			}
		}
		`/usr/sbin/initctl restart pkg-apache22`;
		`/usr/sbin/initctl restart pkg-apache24`;
	}
	else if($machine_type == SYNOLOGY){
		`/sbin/initctl stop httpd-user`;
		`/sbin/initctl start httpd-user`;
	}
	else if($machine_type == NETGEAR) {
		$dpkgOutput = trim(shell_exec('dpkg -l php5-sqlite 2>&1'));
		if(preg_match('/no packages found/', $dpkgOutput)) {
			# install php5-sqlite
			`apt-get install php5-sqlite`;
		}

		$dpkgOutput = trim(shell_exec('dpkg -l libsqlite3-0 2>&1'));
		if(preg_match('/no packages found/', $dpkgOutput)) {
			# install libsqlite3-0
			`apt-get install libsqlite3-0`;
		}

		$dpkgOutput = trim(shell_exec('dpkg -l sqlite 2>&1'));
		if(preg_match('/no packages found/', $dpkgOutput)) {
			# install sqlite
			`apt-get install sqlite`;
		}
		
		system("systemctl restart apache2.service");
	}
	
	validateIdevsutil();
	exit;
}


/*************************************************************************************************************************
* Subroutine Name       : validateIdevsutil
* Objective             : validate idevs util binary file. If it is invalid, downloads the appropriate one from server
**************************************************************************************************************************/
function validateIdevsutil(){

	GLOBAL $binaryPath, $machine_type;
	#$lines = 0;
	$res = '';
	#Checking the validity of idevsutil binary
	$idevsutil = $binaryPath."/idevsutil_IDrive";
	if(file_exists($idevsutil)){
		$helpData = `$idevsutil -h; echo $?`;
	}else{
		system("sh $binaryPath/.scripts/binaryChk.sh $idevsutil $machine_type 2>/dev/null 1>2");
	}
	#if($lines < 50){
		
	if(trim($helpData) != 0){
		system("sh $binaryPath/.scripts/binaryChk.sh $idevsutil $machine_type 2>/dev/null 1>2");
	}
}


/*********************************************************************************************************
* Subroutine Name       : getPHPConfdPath
* Objective             : To get the php conf.d path
* Added By              : Sabin Cheruvattil | 2016-11-25
**********************************************************************************************************/
function getPHPConfdPath($isDSM6=0)
{
	GLOBAL $phpFpmConfPath, $phpNameArray, $machine_type;
	$phpFpmConfPath = array();
	$psPath				= "ps -wwwww";

	if($isDSM6 or $machine_type == ASUSTOR) {
		$psPath 		= "ps -elf";
	}

	$phpFpmPath    		= `$psPath | grep 'php-fpm' | grep 'master process'`;
	preg_match_all("/\/(php.*)\/fpm.conf/", $phpFpmPath, $match);

	$phpNameArray = $match[1];
	if(!in_array('php', $phpNameArray)) {
		array_push($phpNameArray, 'php');
	}
	
	# DSM 6 + Web Station Beta
	if($isDSM6) {
		$phpFpmPath    		= `$psPath | grep 'php-fpm' | grep 'master process'`;
		preg_match_all("/\/(php(\d*))\/php-fpm.conf/", $phpFpmPath, $secmatch);
		foreach($secmatch[1] as $phppack) {
			array_push($phpNameArray, $phppack);
		}
	}
	
    foreach($phpNameArray as $phpName){	
		$pathToPhpBinary 	= trim(`which $phpName`);
		if($pathToPhpBinary != '') {
			$phpIniInfo = `$pathToPhpBinary --ini`;
			$output  	= explode("\n", $phpIniInfo);
			foreach($output as $value) {
				if(preg_match("/^Scan for additional .ini files in:/", $value)) {
						$iniDirPath = trim(preg_replace("/Scan for additional .ini files in:/", '', $value));
						if(strstr($iniDirPath,'/'))
							array_push($phpFpmConfPath,$iniDirPath);
					break;
				}
			}
		}
	}	
	
	if($isDSM6) {
		$phpFpmPath    	= `$psPath | grep 'php-fpm' | grep 'master process' | grep 'php_profile'`;
		preg_match_all("/\((.*)\/fpm\.conf/", $phpFpmPath, $match);
		
		foreach($match[1] as $confdir) {
			array_push($phpFpmConfPath, $confdir . '/conf.d');
		}
	}
	
	if($machine_type == NETGEAR){
		$iniDirPath = "/etc/php5/apache2/conf.d";
		if(is_dir($iniDirPath))
			array_push($phpFpmConfPath,$iniDirPath);
	}		
}

/***********************************************************************************************
* Subroutine Name       : getCompatibleLibpopt
* Objective             : get the appropriate libpopt file based on machine arch
***********************************************************************************************/
function getCompatibleLibpopt($arch="",$basePath="",$libPath)
{
	if(file_exists($basePath."/libpopt")){
		$libpoptPath = $basePath."/libpopt/libpopt.so.0.0.0";
		$archBaseLibpoptPath = "";
		if(preg_match("/armv/i",$arch)){
			$cmd = `uname -a `;
			if(preg_match("/alpine/i", $cmd))
				$archBaseLibpoptPath = $libpoptPath."_alpine";	
			else
				$archBaseLibpoptPath = $libpoptPath."_arm";			
		}
		else if(preg_match("/aarch64/i",$arch)){
			$archBaseLibpoptPath = $libpoptPath."_aarch64";
		}
		else{
			$archBaseLibpoptPath = $libpoptPath."_X86";
		}

		if(file_exists($archBaseLibpoptPath)){
			$orgLibPath = $libPath."/libpopt.so.0.0.0";
			`mv $archBaseLibpoptPath $orgLibPath`;
			`chown root:root $orgLibPath`;
			`chmod 00755 $orgLibPath`;
		}
	}
	else if(file_exists($basePath."/libpopt.so.0.0.0"))
	{ 
		$archBaseLibpoptPath = $basePath."/libpopt.so.0.0.0";
		$orgLibPath = $libPath."/libpopt.so.0.0.0";
		`mv $archBaseLibpoptPath $orgLibPath`;
		`chown root:root $orgLibPath`;
		`chmod 00755 $orgLibPath`;
	}
}

/********************************************************************************************
* Subroutine Name       : validateSu
* Objective             : validates su binary file 
*********************************************************************************************/
function validateSu($suPath=""){
	$outfile = "/tmp/out.txt";
	$suHelpRes = `$suPath --help  1>$outfile 2>>$outfile`;
	$suLines=`wc -l /tmp/out.txt | awk -F " " '{print $1}'`;
	if(file_exists($outfile)){
		unlink($outfile);
	}
	if($suLines < 5){
		return FALSE;
	}
	/*echo "$suPath --help; echo $?;";
	echo $suHelpRes = `$suPath --help; echo $?;`;
	if(trim($suHelpRes) != "0"){	
		echo "dfsaf";
		return FALSE;
	}*/
	return TRUE;
}
#*************************************************************************************************************
# Subroutine Name         : cronPerltoPhpUpdate
# Objective               : updating old cron perl files path to new php path
# Added By                : Vijay Vinoth C
#**************************************************************************************************************/
function cronPerltoPhpUpdate(){
	GLOBAL $cronPath, $perlPath, $phpPath;
	$count = 0;
	$linesCrontabConfigFile = file($cronPath);
	$linesCrontabExLines	= array();
	foreach($linesCrontabConfigFile as $cronTabLine) {
		$cronTabLine = trim($cronTabLine);
		if($cronTabLine == "")
			continue;
		$perlCount = 0;
		if((strpos($cronTabLine,SERVICE.'/user_profile') !== false) && (strpos($cronTabLine,$perlPath) !== false)){
			if(strpos($cronTabLine,'.scripts/Restore_Script_IDrive.pl') !== false) 
				$cronTabLine = str_replace(".scripts/Restore_Script_IDrive.pl", ".scripts/Restore_Script_IDrive.php", $cronTabLine );
			elseif(strpos($cronTabLine,'.scripts/Backup_Script_IDrive.pl') !== false)
				$cronTabLine = str_replace(".scripts/Backup_Script_IDrive.pl", ".scripts/Backup_Script_IDrive.php", $cronTabLine);
			elseif(strpos($cronTabLine,'.scripts/Job_Termination_Script.pl') !== false)
				$cronTabLine = str_replace(".scripts/Job_Termination_Script.pl", ".scripts/Job_Termination_Script.php", $cronTabLine);
				
			$cronTabLine = str_replace("; ".$perlPath." /", "; ".$phpPath." -d open_basedir=NULL /", $cronTabLine, $perlCount);
			if($perlCount == 0){
				$cronTabLineArr = explode(" ",$cronTabLine);
				$cronTabLineArrVal = array_map("convertPerlToPhpFallBack",$cronTabLineArr); 
				$cronTabLine = implode(" ",$cronTabLineArrVal);
			}
			$linesCrontabExLines[] = $cronTabLine."\n";
			$count = $count+1;
		}
		else
			$linesCrontabExLines[] = $cronTabLine."\n";
	}
	
	if($count > 0)
	{
		file_put_contents($cronPath,$linesCrontabExLines);
		configureCron();
	}
 }
 
#*************************************************************************************************************
# Subroutine Name         : configureCron
# Objective               :
# Added By                : Vijay Vinoth C
#**************************************************************************************************************/ 
function configureCron()
{
	GLOBAL $machine_type;
	
	$retVal = 1;
	if($machine_type == SYNOLOGY){
		$retVal = system("/usr/syno/sbin/synoservicectl --restart crond");	 
		# $? perl special variable to collect the error returned by system call
		if($retVal == ""){
			system("synoservice --restart crond");
			$retVal = 0;
		}
		else
			$retVal = 1;
	}
	else if($machine_type == ASUSTOR){
		system("./etc/init.d/S41crond stop");	
		system("./etc/init.d/S41crond start");	
	}
	else if($machine_type == NETGEAR){
		if(file_exists("./etc/init.d/cron"))
			system("./etc/init.d/cron restart");	
		else
			system("service cron restart");
	}
	else {
		$retVal = system("/etc/init.d/crond.sh restart");
		if($retVal == "")
			$retVal  = 0;
		else
			$retVal = 1;
	}
	//$retVal = $?;
	//$retVal = $retVal >> 8;
	return $retVal;

}

function convertPerlToPhpFallBack($str)
{
	GLOBAL $perlPath, $phpPath;
	if(strpos($str,$perlPath) !== false || strpos($perlPath,$str) !== false)
		$str = $phpPath." -d open_basedir=NULL";
	return($str);
}